Bio::Tools::Run::Phylo::Phylip::ProtDist(3)

NAME
Bio::Tools::Run::Phylo::Phylip::ProtDist - Wrapper for the phylip program protdist

SYNOPSIS
  #Create a SimpleAlign object
  @params = ('ktuple' => 2, 'matrix' => 'BLOSUM');
  $factory = Bio::Tools::Run::Alignment::Clustalw->new(@params);
  $inputfilename = 't/data/cysprot.fa';
  $aln = $factory->run($inputfilename); # $aln is a SimpleAlign object.

  # Create the Distance Matrix using a default PAM matrix and id name
  # lengths limit of 30 note to use id name length greater than the
  # standard 10 in protdist, you will need to modify the protdist source
  # code

  @params = ('MODEL' => 'PAM');
  $protdist_factory = Bio::Tools::Run::Phylo::Phylip::ProtDist->new(@params);

  my ($matrix)  = $protdist_factory->run($aln); # an array of Bio::Matrix::PhylipDist matrix

  #finding the distance between two sequences
  my $distance = $matrix->get_entry('protein_name_1','protein_name_2');
  my @column   = $matrix->get_column('protein_name_1');
  my @row      = $martrix->get_row('protein_name_1');
  my @diag     = $matrix->get_diagonal();
  print $matrix->print_matrix;

  #Alternatively, one can create the matrix by passing in a file
  #name containing a multiple alignment in phylip format
  $protdist_factory = Bio::Tools::Run::Phylo::Phylip::ProtDist->new(@params);
  my ($matrix)  = $protdist_factory->run('/home/shawnh/prot.phy');

DESCRIPTION
Wrapper for protdist Joseph Felsentein for creating a distance matrix comparing protein sequences from a multiple alignment file or a Bio::SimpleAlign object and returns a Bio::Matrix::PhylipDist object;

VERSION Support

This wrapper currently supports v3.5 of phylip. There is also support for v3.6 although this is still experimental as v3.6 is still under alpha release and not all functionalities maybe supported.

PARAMETERS FOR PROTDIST COMPUTATION

  MODEL
Title    : MODEL
Description    : (optional)

                  This sets the model of amino acid substitution used
                  in the calculation of the distances.  3 different
                  models are supported:
                  PAM     Dayhoff PAM Matrix(default)
                  KIMURA  Kimura's Distance CAT

                  Categories Distance Usage: @params =
                  ('model'=>'X');#where X is one of the values above

                  Defaults to PAM For more information on the usage of
                  the different models, please refer to the
                  documentation
                  defaults to Equal
                  (0.25,0.25,0.25,0.25) found in the phylip package.

  MULTIPLE
Title : MULTIPLE Description: (optional)

          This allows multiple distance matrices to be generated from multiple
          MSA.

          Usage: @params = ('MULTIPLE'=>100) where the value specifyies the
          number of aligments given.

  ALL SUBSEQUENT PARAMETERS WILL ONLY WORK IN CONJUNCTION WITH
THE Categories Distance MODEL*

  GENCODE
  Title         : GENCODE
  Description   : (optional)

                  This option allows the user to select among various
                  nuclear and mitochondrial genetic codes.

                  Acceptable Values:
                  U           Universal
                  M           Mitochondrial
                  V           Vertebrate mitochondrial
                  F           Fly mitochondrial
                  Y           Yeast mitochondrial
  Usage         : @params = ('gencode'=>'X');
                  where X is one of the letters above
                  Defaults to U

  CATEGORY
Title    : CATEGORY
Description : (optional)

                  This option sets the categorization of amino acids
                  all have groups: (Glu Gln Asp Asn), (Lys Arg His),
                  (Phe Tyr Trp)  plus:
                  G   George/Hunt/Barker:
                          (Cys), (Met   Val  Leu  Ileu),
                          (Gly  Ala  Ser  Thr  Pro)
                  C   Chemical:
                          (Cys   Met), (Val  Leu  Ileu  Gly  Ala  Ser  Thr),
                          (Pro)
                  H   Hall:
                        (Cys), (Met   Val  Leu  Ileu), (Gly  Ala  Ser  Thr),
                        (Pro)

  Usage         : @params = ('category'=>'X');
                  where X is one of the letters above
                  Defaults to G

  PROBCHANGE
  Title       : PROBCHANGE
  Description : (optional)
                 This option sets the ease of changing category of amino
                 acid.  (1.0 if no difficulty of changing,less if less
                 easy. Can't be negative)

  Usage       : @params = ('probchange'=>X) where 0<=X<=1
                Defaults to 0.4570

  TRANS
  Title       : TRANS
  Description : (optional)
                This option sets transition/transversion ratio can be
                any positive number

  Usage        : @params = ('trans'=>X) where X >= 0
                 Defaults to 2

  FREQ
  Title       : FREQ
  Description : (optional)
                This option sets the frequency of each base (A,C,G,T)
                The sum of the frequency must sum to 1.
                For example A,C,G,T = (0.25,0.5,0.125,0.125)

  Usage       : @params = ('freq'=>('W','X','Y','Z')
                where W + X + Y + Z = 1
                Defaults to Equal (0.25,0.25,0.25,0.25)

FEEDBACK

  Mailing Lists
User feedback is an integral part of the evolution of this and other Bioperl modules. Send your comments and suggestions preferably to one of the Bioperl mailing lists. Your participation is much appreciated.

  bioperl-l@bioperl.org          - General discussion
  http://bio.perl.org/MailList.html             - About the mailing lists

  Reporting Bugs
Report bugs to the Bioperl bug tracking system to help us keep track
 the bugs and their resolution. Bug reports can be submitted via
 email or the web:

  bioperl-bugs@bio.perl.org
  http://bio.perl.org/bioperl-bugs/

AUTHOR - Shawn Hoon
Email shawnh@fugu-sg.org

APPENDIX
The rest of the documentation details each of the object methods. Internal methods are usually preceded with a _

  program_name
 Title   : program_name
 Usage   : >program_name()
 Function: holds the program name
 Returns:  string
 Args    : None

  program_dir
 Title   : program_dir
 Usage   : ->program_dir()
 Function: returns the program directory, obtiained from ENV variable.
 Returns:  string
 Args    :

  idlength
 Title   : idlength
 Usage   : $obj->idlength ($newval)
 Function:
 Returns : value of idlength
 Args    : newvalue (optional)

  run
 Title   : run
 Usage   :
        $inputfilename = 't/data/prot.phy';
        $matrix= $prodistfactory->run($inputfilename);
or
        $seq_array_ref = \@seq_array; @seq_array is array of Seq objs
        $aln = $protdistfactory->align($seq_array_ref);
        $matrix = $protdistfactory->run($aln);

 Function: Create a distance matrix from a SimpleAlign object or a multiple alignment file
 Example :
 Returns : L<Bio::Matrix::PhylipDist>
 Args    : Name of a file containing a multiple alignment in Phylip format
           or an SimpleAlign object

 Throws an exception if argument is not either a string (eg a
 filename) or a Bio::SimpleAlign object. If
 argument is string, throws exception if file corresponding to string
 name can not be found.

  _run
 Title   :  _run
 Usage   :  Internal function, not to be called directly
 Function:  makes actual system call to protdist program
 Example :
 Returns : Bio::Tree object
 Args    : Name of a file containing a set of multiple alignments in Phylip format
           and a parameter string to be passed to protdist

  create_distance_matrix
 Title   : create_distance_matrix
 Usage   : my $file = $app->create_distance_matrix($treefile);
 Function: This method is deprecated. Please use run method.
 Returns : L<Bio::Matrix::PhylipDist>
 Args    : Name of a file containing a multiple alignment in Phylip format
           or an SimpleAlign object

 Throws an exception if argument is not either a string (eg a
 filename) or a Bio::SimpleAlign object. If
 argument is string, throws exception if file corresponding to string
 name can not be found.

  _setinput()
 Title   :  _setinput
 Usage   :  Internal function, not to be called directly
 Function:   Create input file for protdist program
 Example :
 Returns : name of file containing a multiple alignment in Phylip format
 Args    : SimpleAlign object reference or input file name

  _setparams()
 Title   :  _setparams
 Usage   :  Internal function, not to be called directly
 Function:   Create parameter inputs for protdist program
 Example :
 Returns : parameter string to be passed to protdist
 Args    : name of calling object

Bio::Tools::Run::Wrapper methods

  no_param_checks
 Title   : no_param_checks
 Usage   : $obj->no_param_checks($newval)
 Function: Boolean flag as to whether or not we should
           trust the sanity checks for parameter values
 Returns : value of no_param_checks
 Args    : newvalue (optional)

  save_tempfiles
 Title   : save_tempfiles
 Usage   : $obj->save_tempfiles($newval)
 Function:
 Returns : value of save_tempfiles
 Args    : newvalue (optional)

  outfile_name
 Title   : outfile_name
 Usage   : my $outfile = $protdist->outfile_name();
 Function: Get/Set the name of the output file for this run
           (if you wanted to do something special)
 Returns : string
 Args    : [optional] string to set value to

  tempdir
 Title   : tempdir
 Usage   : my $tmpdir = $self->tempdir();
 Function: Retrieve a temporary directory name (which is created)
 Returns : string which is the name of the temporary directory
 Args    : none

  cleanup
 Title   : cleanup
 Usage   : $codeml->cleanup();
 Function: Will cleanup the tempdir directory after a PAML run
 Returns : none
 Args    : none

  io
 Title   : io
 Usage   : $obj->io($newval)
 Function:  Gets a L<Bio::Root::IO> object
 Returns : L<Bio::Root::IO>
 Args    : none